VERSION 1.0 CLASS
BEGIN
  MultiUse = -1  'True
END
Attribute VB_Name = "Lyric"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = True
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = False
Public Lyrics As String
Public Artist As String
Public Title As String
Public Album As String
Public Track As Integer
Public Comment As String
Public Year As Integer
Public Enum SortModes
    SMArtist = 1
    SMTitle = 2
    SMAlbum = 3
    SMComment = 4
    SMTrack = 5
    SMYear = 6
End Enum

Function IsGreaterThan(Other As Lyric, SortMode As SortModes) As Boolean
    Dim S1 As String, S2 As String
    Select Case SortMode
    Case SMArtist: S1 = UCase(Artist): S2 = UCase(Other.Artist)
        If S1 = S2 Then
            IsGreaterThan = (UCase(Title) > UCase(Other.Title))
        Else
            IsGreaterThan = (S1 > S2)
        End If
    Case SMTitle: IsGreaterThan = (UCase(Title) > UCase(Other.Title))
    Case SMAlbum: IsGreaterThan = (UCase(Album) > UCase(Other.Album))
    Case SMAlbum: S1 = UCase(Album): S2 = UCase(Other.Album)
        If S1 = S2 Then
            IsGreaterThan = IsGreaterThan(Other, SMArtist)
        Else
            IsGreaterThan = (S1 > S2)
        End If
    Case SMComment: IsGreaterThan = (UCase(Comment) > UCase(Other.Comment))
    Case SMTrack: IsGreaterThan = (Track > Other.Track)
    Case SMYear: IsGreaterThan = (Year > Other.Year)
    Case Else: Debug.Assert False
    End Select
End Function
