VERSION 5.00
Begin VB.Form SortForm 
   BorderStyle     =   3  'Fixed Dialog
   Caption         =   "Sort"
   ClientHeight    =   3165
   ClientLeft      =   45
   ClientTop       =   330
   ClientWidth     =   1695
   Icon            =   "SortForm.frx":0000
   LinkTopic       =   "Form1"
   MaxButton       =   0   'False
   MinButton       =   0   'False
   ScaleHeight     =   3165
   ScaleWidth      =   1695
   ShowInTaskbar   =   0   'False
   StartUpPosition =   3  'Windows Default
   Begin VB.CommandButton CancelBtn 
      Cancel          =   -1  'True
      Caption         =   "Cancel"
      Height          =   375
      Left            =   240
      TabIndex        =   8
      Top             =   2520
      Width           =   1215
   End
   Begin VB.CommandButton SortBtn 
      Caption         =   "Sort"
      Default         =   -1  'True
      Height          =   375
      Left            =   240
      TabIndex        =   7
      Top             =   2040
      Width           =   1215
   End
   Begin VB.OptionButton SortByYear 
      Caption         =   "Year"
      Height          =   255
      Left            =   240
      TabIndex        =   6
      Top             =   1680
      Width           =   1215
   End
   Begin VB.OptionButton SortByTrack 
      Caption         =   "Track #"
      Height          =   255
      Left            =   240
      TabIndex        =   5
      Top             =   1440
      Width           =   1215
   End
   Begin VB.OptionButton SortByComment 
      Caption         =   "Comment"
      Height          =   255
      Left            =   240
      TabIndex        =   4
      Top             =   1200
      Width           =   1215
   End
   Begin VB.OptionButton SortByAlbum 
      Caption         =   "Album"
      Height          =   255
      Left            =   240
      TabIndex        =   3
      Top             =   960
      Width           =   1215
   End
   Begin VB.OptionButton SortByTitle 
      Caption         =   "Title"
      Height          =   255
      Left            =   240
      TabIndex        =   2
      Top             =   720
      Width           =   1215
   End
   Begin VB.OptionButton SortByArtist 
      Caption         =   "Artist"
      Height          =   255
      Left            =   240
      TabIndex        =   1
      Top             =   480
      Width           =   1215
   End
   Begin VB.Label Label1 
      Caption         =   "Sort by:"
      Height          =   255
      Left            =   240
      TabIndex        =   0
      Top             =   120
      Width           =   855
   End
End
Attribute VB_Name = "SortForm"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False
Private Sub CancelBtn_Click()
    Unload Me
End Sub

Private Sub Form_Load()
    SortByArtist.Value = True
End Sub

Private Sub SortBtn_Click()
    Dim Criteria As SortModes
    If SortByArtist.Value Then Criteria = SMArtist
    If SortByTitle.Value Then Criteria = SMTitle
    If SortByAlbum.Value Then Criteria = SMAlbum
    If SortByComment.Value Then Criteria = SMComment
    If SortByTrack.Value Then Criteria = SMTrack
    If SortByYear.Value Then Criteria = SMYear
    DoSort Criteria
    Unload Me
End Sub

Sub DoSort(Criteria As SortModes)
    Dim I As Long, J As Long, H As Long
    Dim Temp As Lyric
    
    ' Find largest 'H' value where H is (3^K-1)/2 < Ubound(Orders)/9
    ' The sequence of increments used is (3^K-1)/2, ..., 13, 4, 1
    H = 1: Do
        H = H * 3 + 1
    Loop While H < UBound(Lyrics) / 9
    
    Do
        ' Perform insertion sort on each set of elements Orders(H*N+S)
        ' where S specifies the set and whose range is 1..H, and N is
        ' 0..X where X is the largest value such that H*N+C is always
        ' <= UBound(Orders).  The insertion sorts on the various
        ' subarrays are interleaved, as is normal for this algorithm.
        For I = 1 To UBound(Lyrics) - H
            J = I
            Set Temp = Lyrics(I + H)
            Do
                If Not Lyrics(J).IsGreaterThan(Temp, Criteria) Then Exit Do
                Set Lyrics(J + H) = Lyrics(J)
                J = J - H
            Loop While J > 0
            Set Lyrics(J + H) = Temp
        Next
        H = H \ 3 ' Equivalent to (H-1) \ 3
    Loop While H > 0
End Sub

